/*
  Module Timers
  part of Arduino Mega Server project
*/

unsigned long timer1s;
unsigned long timer5s;
unsigned long timer10s;
unsigned long timer20s;
unsigned long timer30s;
unsigned long timer1m;
unsigned long timer3m;
unsigned long timer5m;
unsigned long timer15m; // добавил таймера
unsigned long timer30m;
unsigned long timer1h;
unsigned long timer1d;
unsigned long timer7d;
unsigned long timer30d; // добавил таймера

void initTimers() {
  unsigned long uptimeSec = millis() / 1000;
  timer1s  = uptimeSec;  
  timer5s  = uptimeSec; 
  timer10s = uptimeSec;
  timer20s = uptimeSec;
  timer30s = uptimeSec;
  timer1m  = uptimeSec;
  timer3m  = uptimeSec;
  timer5m  = uptimeSec;
  timer15m = uptimeSec; // добавил таймера
  timer30m = uptimeSec;
  timer1h  = uptimeSec;
  timer1d  = uptimeSec;
  timer7d  = uptimeSec;
  timer30d = uptimeSec; // добавил таймера
}

void eraseCyclos() {
  cycle1s  = false;
  cycle5s  = false;
  cycle20s = false;
  cycle10s = false;
  cycle30s = false;
  cycle1m  = false;
  cycle3m  = false;
  cycle5m  = false;
  cycle15m = false; // добавил таймера
  cycle30m = false;
  cycle1h  = false;
  cycle1d  = false;
  cycle7d  = false;
  cycle30d = false; // добавил таймера
}

void workTimers() {
  unsigned long timeSec = millis() / 1000;
  if (timeSec - timer1s >=   1) {
                                    timer1s  = timeSec; cycle1s  = true;
    if (timeSec - timer5s  >=   5) {timer5s  = timeSec; cycle5s  = true;}
    if (timeSec - timer20s >=  20) {timer20s = timeSec; cycle20s = true;}
    if (timeSec - timer10s >=  10) {timer10s = timeSec; cycle10s = true;}
    if (timeSec - timer30s >=  30) {timer30s = timeSec; cycle30s = true;}
    if (timeSec - timer1m  >=  60) {timer1m  = timeSec; cycle1m  = true;}
    if (timeSec - timer3m  >= 180) {timer3m  = timeSec; cycle3m  = true;}
    if (timeSec - timer5m  >= 300) {timer5m  = timeSec; cycle5m  = true;}
    if (timeSec - timer15m >= 900) {timer15m = timeSec; cycle15m = true;} // добавил таймера
    if (timeSec - timer30m >= 1800)    {timer30m = timeSec; cycle30m = true;}
    if (timeSec - timer1h  >= 3600)    {timer1h  = timeSec; cycle1h  = true;}
    if (timeSec - timer1d  >= 86400)   {timer1d  = timeSec; cycle1d  = true;}
    if (timeSec - timer7d  >= 604800)  {timer7d  = timeSec; cycle1d  = true;}
    if (timeSec - timer30d >= 2592000) {timer30d = timeSec; cycle1d  = true;} // добавил таймера
  }
}

//=======================================
// timer

unsigned long tmr1 = millis();
unsigned long interval = 0;

boolean timer1(long minInt, long maxInt) {
  unsigned long dely = millis() - tmr1;
  if (dely > interval) {
    interval = random(minInt, maxInt);
    tmr1 = millis();
    return true;
  }
  return false;
}
//==============================================

