/*
  Module Wi-Fi
  part of Arduino Mega Server project
*/

//char ssid[] = "Viking";
//char pass[] = "DctCegth2035";

char ssid[] = "mega";
char pass[] = "11111111";

IPAddress ip = SELF_IP;
IPAddress gateway(192, 168, 2, 100);
IPAddress subnet(255, 255, 255, 0);

IPAddress primaryDNS(8, 8, 8, 8); 
IPAddress secondaryDNS(8, 8, 4, 4); 

void initWifi() {
  initStart(F("Wi-Fi"), false);
  Serial.print(F(" Connecting to ")); Serial.print(ssid); Serial.print(F(" "));
  WiFi.mode(WIFI_STA);
  delay(10);
  WiFi.begin(ssid, pass);
  //WiFi.config(ip, gateway, subnet);
  WiFi.config(ip, gateway, subnet, primaryDNS, secondaryDNS);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(F("."));
  }
  Serial.println();
  Serial.println(F(" WiFi:       connected"));
  Serial.print(F(" IP address: "));
  Serial.println(WiFi.localIP());
  initDone(false);

  
}
